;iPhone8x - iPhone/iPod Touch USB Interface
; (C) 2009 by Brandon Wilson. All rights reserved. 
;Portions in util.asm, usb8x.inc, equates.inc (C) Dan Englender.

 include "settings.inc" ;Specific settings for this application
 NOLIST
 include "ti83plus.inc"
 LIST
 include "equates.inc" ;Equates and macros to be used
 include "header.asm"
 GLOBALS ON
 include "usb8x.inc" ;usb8x equates

 SEGMENT MAIN

 Var USBDriverCall,32	; 32; RAM calls for U_CALL and callback routine
 Var USBDriverBuf,128	;128; Static buffer for USB driver's usage

 EXTERN DispHexHL,DispHexA,IPutS

;-----------------------------------------------------------------------------
Init:
       ld hl,DummyCallback
       ld de,DummyCallbackLoc
       ld bc,DummyCallbackEnd-DummyCallback
       ldir
       U_CALL_INIT DummyCallbackLoc
       jr c,ExitApp
       ld hl,USBDriverBuf
       U_CALL DriverInit
       jr c,ExitAppError

       B_CALL ClrLCDFull
       B_CALL HomeUp
       ld hl,sInstructions1
       call IPutS
       B_CALL GetKey
       cp kQuit
       jr z,ExitApp

       B_CALL ClrLCDFull
       B_CALL HomeUp
       ld hl,sWorking0
       call IPutS

;;;       ld hl,DescriptorBuffer
;;;       ld de,DummyCallbackLoc
;;;       U_CALL AutoSetup
;;;       jr c,ExitAppError

       U_CALL  HostInit
       jr c,ExitAppError

       B_CALL ClrLCDFull
       B_CALL HomeUp
       ld hl,sWorking1
       call IPutS

       ld     b,1
       U_CALL  ConfigureDevice
       jr c,ExitAppError
	
       B_CALL ClrLCDFull
       B_CALL HomeUp
       ld hl,sWorking2
       call IPutS

       ld hl,sRunCommand
       rst 20h
       B_CALL OP1ToOP2

       ld hl,sControlRequest
       rst 20h
       ld hl,OP1
       ld de,OP2

       ld b,10h
       U_CALL SendControlDataOut

;;;    jr c,ExitAppError
       B_CALL ClrLCDFull
       B_CALL HomeUp
       ld hl,sSuccess
       call IPutS
       B_CALL GetKey
ExitApp:
       B_CALL ClrLCDFull
       B_CALL HomeUp
       B_CALL ClrTxtShd
       U_CALL HostKill
       U_CALL DriverKill
       B_JUMP JForceCmdNoChar
ExitAppError:
       B_CALL ClrLCDFull
       B_CALL HomeUp
       ld a,'E'
       B_CALL PutC
       U_CALL GetErrorCode
       ld h,b
       ld l,c
       call DispHexHL
       B_CALL GetKey
       B_CALL ClrLCDFull
       B_CALL HomeUp
       B_CALL ClrTxtShd
       U_CALL HostKill
       U_CALL DriverKill
       B_JUMP JForceCmdNoChar

DummyCallback:
       ret
DummyCallbackEnd:

sControlRequest:
       DB 40h,0,0,0,0,0,16,0
sRunCommand:
       DB "run rs",0Dh,0Ah,0,0,0,0,0,0,0,0
sSuccess:
       DB "Success!",0
sInstructions1:
       DB "Put the ipt2g   "
       DB "in recovery mode"
       DB "and THEN plug it"
       DB "in, then press  "
       DB "any key.",0
sWorking0:
       DB "USB Init...",0
sWorking1:
       DB "Configuring...",0
sWorking2:
       DB "run rs...",0

